/*! waveform-playlist 0.2.0
Written by: Naomi Aro
Website: http://naomiaro.github.io/waveform-playlist
License: MIT */
"use strict";var WaveformPlaylist={init:function(a){var b,c,d,e,f,g=this,h=this.config.getContainer(),i=h.querySelector(".playlist-tracks"),j=document.createDocumentFragment();for(WaveformPlaylist.makePublisher(this),this.storage=Object.create(WaveformPlaylist.Storage),h.style.overflow="hidden",this.trackContainer=i,this.trackContainer.style.position="relative",this.trackContainer.style.overflow="auto",this.trackEditors=[],f=Object.create(WaveformPlaylist.AudioControls,{config:{value:this.config}}),f.init(),this.config.isTimeScaleEnabled()&&(this.timeScale=Object.create(WaveformPlaylist.TimeScale,{config:{value:this.config}}),this.timeScale.init(),f.on("changeresolution","onResolutionChange",this.timeScale),this.on("trackscroll","onTrackScroll",this.timeScale)),b=0,c=a.length;c>b;b++)d=Object.create(WaveformPlaylist.TrackEditor,{config:{value:this.config}}),e=d.loadTrack(a[b]),this.trackEditors.push(d),j.appendChild(e),f.on("trackedit","onTrackEdit",d),f.on("changeresolution","onResolutionChange",d),d.on("activateSelection","onAudioSelection",f),d.on("deactivateSelection","onAudioDeselection",f),d.on("changecursor","onCursorSelection",f),d.on("changecursor","onSelectUpdate",this),d.on("changeshift","onChangeShift",this),d.on("unregister",function(){var a=this;f.remove("trackedit","onTrackEdit",a),f.remove("changeresolution","onResolutionChange",a),g.removeTrack(a)}.bind(d));this.trackContainer.appendChild(j),this.trackContainer.onscroll=this.onTrackScroll.bind(this),this.sampleRate=this.config.getSampleRate(),this.scrollTimeout=!1,this.animationRequest,this.animationCallback=this.updateEditor.bind(this),this.on("playbackcursor","onAudioUpdate",f),f.on("playlistsave","save",this),f.on("playlistrestore","restore",this),f.on("rewindaudio","rewind",this),f.on("fastforwardaudio","fastForward",this),f.on("playaudio","play",this),f.on("pauseaudio","pause",this),f.on("stopaudio","stop",this),f.on("trimaudio","onTrimAudio",this),f.on("changestate","onStateChange",this),f.on("changeselection","onSelectionChange",this),this.audioControls=f},removeTrack:function(a){var b,c,d,e=this.trackEditors;for(b=0,c=e.length;c>b;b++)if(d=e[b],d===a)return void e.splice(b,1)},resize:function(){this.timeScale.onResize()},onTrimAudio:function(){this.activeTrack&&this.activeTrack.trim()},onSelectionChange:function(a){this.config.setCursorPos(a.start),this.activeTrack&&this.activeTrack.setSelectedArea(a.start,a.end)},onStateChange:function(){var a,b,c=this.trackEditors,d=this.config.getState();for(a=0,b=c.length;b>a;a++)c[a].deactivate(),c[a].setState(d)},onTrackScroll:function(){var a=this;a.scrollTimeout||(a.scrollTimeout=setTimeout(function(){a.config.setTrackScroll(a.trackContainer.scrollLeft,a.trackContainer.scrollTop),a.fire("trackscroll"),a.scrollTimeout=!1},25))},activateTrack:function(a){var b,c,d,e=this.trackEditors;for(b=0,c=e.length;c>b;b++)d=e[b],d===a?(d.activate(),this.activeTrack=a):d.deactivate()},onSelectUpdate:function(a){var b,c,d=this.trackEditors;if(this.activateTrack(a.editor),this.isPlaying())this.stop(),setTimeout(this.play.bind(this),60);else if(void 0!==this.pausedAt)for(this.pausedAt=void 0,b=0,c=d.length;c>b;b++)d[b].showProgress(0)},onChangeShift:function(a){var b,c,d=this.trackEditors,e=0,f=0;for(b=0,c=d.length;c>b;b++)e=Math.max(e,d[b].drawer.containerWidth),f=Math.max(f,d[b].endTime);for(b=0,c=d.length;c>b;b++)d[b].drawer.container.style.width=e+"px";this.duration=f},rewind:function(){void 0!==this.activeTrack?this.activeTrack.notifySelectUpdate(0,0):this.config.setCursorPos(0),this.stop(),this.trackContainer.scrollLeft=0,this.config.setTrackScroll(0),this.fire("trackscroll")},fastForward:function(){var a=this.trackContainer.scrollWidth,b=this.trackContainer.offsetWidth,c=Math.max(a-b,0);void 0!==this.activeTrack?this.activeTrack.notifySelectUpdate(this.duration,this.duration):this.config.setCursorPos(this.duration),this.stop(),this.trackContainer.scrollLeft=c,this.config.setTrackScroll(c),this.fire("trackscroll")},getSelected:function(){return this.activeTrack?this.activeTrack.selectedArea:void 0},isPlaying:function(){var a,b,c=this.trackEditors,d=!1;for(a=0,b=c.length;b>a;a++)d=d||c[a].isPlaying();return d},play:function(){var a,b,c,d=this.trackEditors,e=this.config.getCurrentTime(),f=this.config.getCursorPos(),g=this.getSelected();for(void 0!==g&&g.endTime>f&&(f=g.startTime,c=g.endTime),this.pausedAt&&(f=this.pausedAt),a=0,b=d.length;b>a;a++)d[a].schedulePlay(e,f,c);this.lastPlay=e,this.animationRequest=window.requestAnimationFrame(this.animationCallback)},pause:function(){var a,b,c=this.trackEditors,d=this.config.getCurrentTime(),e=this.config.getCursorPos();for(this.pausedAt&&(e=this.pausedAt),this.pausedAt=d-this.lastPlay+e,window.cancelAnimationFrame(this.animationRequest),a=0,b=c.length;b>a;a++)c[a].scheduleStop(d)},stop:function(){var a,b,c=this.trackEditors,d=this.config.getCurrentTime();for(this.pausedAt=void 0,window.cancelAnimationFrame(this.animationRequest),a=0,b=c.length;b>a;a++)c[a].scheduleStop(d),c[a].showProgress(0)},updateEditor:function(){var a,b,c,d=this.trackEditors,e=this.config.getCurrentTime(),f=e-this.lastPlay,g=this.config.getCursorPos();if(this.pausedAt&&(g=this.pausedAt),this.isPlaying()){if(f){for(c=g+f,a=0,b=d.length;b>a;a++)d[a].showProgress(c);this.fire("playbackcursor",{seconds:c})}this.animationRequest=window.requestAnimationFrame(this.animationCallback)}else{for(a=0,b=d.length;b>a;a++)d[a].showProgress(0);this.pausedAt=void 0,window.cancelAnimationFrame(this.animationRequest)}},getJson:function(){var a,b,c,d=this.trackEditors,e=[];for(a=0,b=d.length;b>a;a++)e.push(d[a].getTrackDetails());return c=JSON.stringify(e),e},save:function(){var a,b,c=this.trackEditors,d=[];for(a=0,b=c.length;b>a;a++)d.push(c[a].getTrackDetails());this.storage.save("test",d)},restore:function(){var a;a=this.storage.restore("test"),this.destroy(),this.init(a)},destroy:function(){var a,b,c=this.trackEditors;for(a=0,b=c.length;b>a;a++)c[a].reset();this.audioControls.reset(),this.timeScale&&this.timeScale.reset(),this.reset(),this.trackContainer.innerHTML=""}};WaveformPlaylist.unitConversions={samplesToSeconds:function(a){return a/this.sampleRate},secondsToSamples:function(a){return Math.ceil(a*this.sampleRate)},samplesToPixels:function(a){return~~(a/this.resolution)},pixelsToSamples:function(a){return~~(a*this.resolution)},pixelsToSeconds:function(a){return a*this.resolution/this.sampleRate},secondsToPixels:function(a){return~~(a*this.sampleRate/this.resolution)}},WaveformPlaylist.curves={createLinearBuffer:function(a,b){var c,d,e=new Float32Array(a),f=a-1;for(c=0;a>c;c++)d=c/f,b>0?e[c]=d:e[c]=1-d;return e},createExponentialBuffer:function(a,b){var c,d,e,f=new Float32Array(a),g=a-1;for(c=0;a>c;c++)d=c/g,e=b>0?c:a-1-c,f[e]=Math.exp(2*d-1)/Math.exp(1);return f},createSCurveBuffer:function(a,b){var c,d=new Float32Array(a);for(c=0;a>c;++c)d[c]=Math.sin(Math.PI*c/a-b)/2+.5;return d},createLogarithmicBuffer:function(a,b,c){var d,e,f=new Float32Array(a),g=""+a+b+c,h=[],i=0;if(h[g])return h[g];for(e=0;a>e;e++)d=c>0?e:a-1-e,i=e/a,f[d]=Math.log(1+b*i)/Math.log(1+b);return h[g]=f,f}},WaveformPlaylist.mixin=function(a,b){Object.keys(b).forEach(function(c){a[c]=b[c]})},WaveformPlaylist.publisher={subscribers:{any:[]},on:function(a,b,c){a=a||"any",b="function"==typeof b?b:c[b],"undefined"==typeof this.subscribers[a]&&(this.subscribers[a]=[]),this.subscribers[a].push({fn:b,context:c||this})},remove:function(a,b,c){this.visitSubscribers("unsubscribe",a,b,c)},fire:function(a,b){this.visitSubscribers("publish",a,b)},reset:function(){this.subscribers={any:[]}},visitSubscribers:function(a,b,c,d){var e,f=b||"any",g=this.subscribers[f],h=g?g.length:0;for(e=0;h>e;e+=1)"publish"===a?g[e].fn.call(g[e].context,c):g[e].fn===c&&g[e].context===d&&g.splice(e,1)}},WaveformPlaylist.makePublisher=function(a){var b,c=WaveformPlaylist.publisher;for(b in c)c.hasOwnProperty(b)&&"function"==typeof c[b]&&(a[b]=c[b]);a.subscribers={any:[]}},WaveformPlaylist.states=WaveformPlaylist.states||{},WaveformPlaylist.states.cursor={classes:"state-cursor",enter:function(){var a=this.currentState;this.container.onmousedown=a.event.bind(this),this.container.classList.add(a.classes)},leave:function(){var a=this.currentState;this.container.onmousedown=null,this.container.classList.remove(a.classes)},event:function(a){a.preventDefault();var b,c,d=a.layerX||a.offsetX;b=this.drawer.findLayerOffset(a.target),d+=b,c=this.pixelsToSeconds(d),this.notifySelectUpdate(c,c)}},WaveformPlaylist.states=WaveformPlaylist.states||{},WaveformPlaylist.states.fadein={classes:"state-fadein",enter:function(){var a=this.currentState;this.container.onmousedown=a.event.bind(this),this.container.classList.add(a.classes)},leave:function(){var a=this.currentState;this.container.onmousedown=null,this.container.classList.remove(a.classes)},event:function(a){var b,c=a.layerX||a.offsetX,d="FadeIn",e=this.config.getFadeType(),f=this.drawer.pixelOffset,g=f+this.drawer.width;b=this.drawer.findLayerOffset(a.target),c+=b,this.removeFadeType(d),c>=f&&g>=c&&this.createFade(d,e,0,c-f)}},WaveformPlaylist.states=WaveformPlaylist.states||{},WaveformPlaylist.states.fadeout={classes:"state-fadeout",enter:function(){var a=this.currentState;this.container.onmousedown=a.event.bind(this),this.container.classList.add(a.classes)},leave:function(){var a=this.currentState;this.container.onmousedown=null,this.container.classList.remove(a.classes)},event:function(a){var b,c=a.layerX||a.offsetX,d="FadeOut",e=this.config.getFadeType(),f=this.drawer.pixelOffset,g=f+this.drawer.width;b=this.drawer.findLayerOffset(a.target),c+=b,this.removeFadeType(d),c>=f&&g>=c&&this.createFade(d,e,c-f,this.drawer.width)}},WaveformPlaylist.states=WaveformPlaylist.states||{},WaveformPlaylist.states.select={classes:"state-select",enter:function(){var a=this.currentState;this.container.onmousedown=a.event.bind(this),this.container.classList.add(a.classes)},leave:function(){var a=this.currentState;this.container.onmousedown=null,this.container.classList.remove(a.classes)},event:function(a){a.preventDefault();var b,c,d,e=this.container,f=this,g=a.layerX||a.offsetX;c=f.drawer.findLayerOffset(a.target),g+=c,b=f.pixelsToSeconds(g),e.onmousemove=function(a){a.preventDefault();var b,c,d=f.drawer.findLayerOffset(a.target),e=d+(a.layerX||a.offsetX),h=Math.min(e,g),i=Math.max(e,g);b=f.pixelsToSeconds(h),c=f.pixelsToSeconds(i),f.notifySelectUpdate(b,c)},d=function(a){a.preventDefault();var b,c,d,h,i=f.drawer.findLayerOffset(a.target),j=i+(a.layerX||a.offsetX);b=Math.min(g,j),c=Math.max(g,j),d=f.pixelsToSeconds(b),h=f.pixelsToSeconds(c),f.notifySelectUpdate(d,h,a.shiftKey),e.onmousemove=e.onmouseup=e.onmouseleave=null},e.onmouseup=e.onmouseleave=d}},WaveformPlaylist.states=WaveformPlaylist.states||{},WaveformPlaylist.states.shift={classes:"state-shift",enter:function(){var a=this.currentState;this.container.onmousedown=a.event.bind(this),this.container.classList.add(a.classes)},leave:function(){var a=this.currentState;this.container.onmousedown=null,this.container.classList.remove(a.classes)},event:function(a){a.preventDefault();var b,c=this.container,d=this,e=a.pageX,f=0,g=0,h=d.leftOffset/d.resolution;c.onmousemove=function(a){a.preventDefault();var b=a.pageX;f=b-e,g=h+f,d.setLeftOffset(d.pixelsToSamples(g))},b=function(a){a.preventDefault();var b=d.pixelsToSeconds(f);c.onmousemove=c.onmouseup=c.onmouseleave=null,d.setLeftOffset(d.pixelsToSamples(g)),d.startTime=d.startTime+b,d.endTime=d.endTime+b},c.onmouseup=c.onmouseleave=b}},WaveformPlaylist.Config=function(a){var b,c=this;b={ac:new(window.AudioContext||window.webkitAudioContext),resolution:4096,minResolution:500,maxResolution:2e4,timeFormat:"hh:mm:ss.uu",mono:!0,fadeType:"logarithmic",timescale:!1,UITheme:"default",waveOutlineColor:"white",timeColor:"grey",fadeColor:"black",waveHeight:128,trackscroll:{left:0,top:0},state:"select",cursorPos:0},a=Object.create(a),Object.keys(b).forEach(function(c){c in a||(a[c]=b[c])}),c.getContainer=function(){return a.container},c.isTimeScaleEnabled=function(){return a.timescale},c.getFadeType=function(){return a.fadeType},c.isDisplayMono=function(){return a.mono},c.getUITheme=function(){return a.UITheme},c.getCursorPos=function(){return a.cursorPos},c.getState=function(){return a.state},c.getAudioContext=function(){return a.ac},c.getSampleRate=function(){return a.ac.sampleRate},c.getCurrentTime=function(){return a.ac.currentTime},c.getTimeFormat=function(){return a.timeFormat},c.getMinResolution=function(){return a.minResolution},c.getMaxResolution=function(){return a.maxResolution},c.getResolution=function(){return a.resolution},c.getWaveHeight=function(){return a.waveHeight},c.getColorScheme=function(){return{waveOutlineColor:a.waveOutlineColor,timeColor:a.timeColor,fadeColor:a.fadeColor,selectBorderColor:a.selectBorderColor,selectBackgroundColor:a.selectBackgroundColor}},c.getTrackScroll=function(){var b=a.trackscroll;return{left:b.left,top:b.top}},c.setResolution=function(b){a.resolution=b},c.setTimeFormat=function(b){a.timeFormat=b},c.setFadeType=function(b){a.fadeType=b},c.setDisplayMono=function(b){a.mono=b},c.setCursorPos=function(b){a.cursorPos=b},c.setState=function(b){a.state=b},c.setTrackScroll=function(b,c){var d=a.trackscroll;d.left=void 0!==b?b:d.left,d.top=void 0!==c?c:d.top}},WaveformPlaylist.AudioControls={groups:{"audio-select":["btns_audio_tools"]},classes:{disabled:"disabled",active:"active"},events:{"btn-rewind":{click:"rewindAudio"},"btn-fast-forward":{click:"fastForwardAudio"},"btn-play":{click:"playAudio"},"btn-pause":{click:"pauseAudio"},"btn-stop":{click:"stopAudio"},"btn-cursor":{click:"changeState"},"btn-select":{click:"changeState"},"btn-shift":{click:"changeState"},"btn-fadein":{click:"changeState"},"btn-fadeout":{click:"changeState"},"btn-save":{click:"save"},"btn-open":{click:"open"},"btn-trim-audio":{click:"trimAudio"},"time-format":{change:"changeTimeFormat"},"audio-pos":{},"audio-start":{blur:"validateCueIn"},"audio-end":{blur:"validateCueOut"},"btn-logarithmic":{click:"changeDefaultFade"},"btn-linear":{click:"changeDefaultFade"},"btn-exponential":{click:"changeDefaultFade"},"btn-sCurve":{click:"changeDefaultFade"},"btn-zoom-in":{click:"zoomIn"},"btn-zoom-out":{click:"zoomOut"}},validateCue:function(a){var b,c,d;return b={seconds:/^\d+$/,thousandths:/^\d+\.\d{3}$/,"hh:mm:ss":/^[0-9]{2,}:[0-5][0-9]:[0-5][0-9]$/,"hh:mm:ss.u":/^[0-9]{2,}:[0-5][0-9]:[0-5][0-9]\.\d{1}$/,"hh:mm:ss.uu":/^[0-9]{2,}:[0-5][0-9]:[0-5][0-9]\.\d{2}$/,"hh:mm:ss.uuu":/^[0-9]{2,}:[0-5][0-9]:[0-5][0-9]\.\d{3}$/},c=b[this.timeFormat],d=c.test(a)},cueToSeconds:function(a){function b(a){var b,c=a.split(":"),d=3600*parseInt(c[0],10),e=60*parseInt(c[1],10),f=parseFloat(c[2]);return b=d+e+f}var c,d,e;return c={seconds:function(a){return parseInt(a,10)},thousandths:function(a){return parseFloat(a)},"hh:mm:ss":function(a){return b(a)},"hh:mm:ss.u":function(a){return b(a)},"hh:mm:ss.uu":function(a){return b(a)},"hh:mm:ss.uuu":function(a){return b(a)}},d=c[this.timeFormat],e=d(a)},cueFormatters:function(a){function b(a,b){var c,d,e,f;return c=parseInt(a/3600,10)%24,d=parseInt(a/60,10)%60,e=a%60,e=e.toFixed(b),f=(10>c?"0"+c:c)+":"+(10>d?"0"+d:d)+":"+(10>e?"0"+e:e)}var c={seconds:function(a){return a.toFixed(0)},thousandths:function(a){return a.toFixed(3)},"hh:mm:ss":function(a){return b(a,0)},"hh:mm:ss.u":function(a){return b(a,1)},"hh:mm:ss.uu":function(a){return b(a,2)},"hh:mm:ss.uuu":function(a){return b(a,3)}};return c[a]},init:function(){var a,b,c,d,e,f,g,h,i=this,j=this.events;WaveformPlaylist.makePublisher(this),this.ctrls={},f=this.config.getContainer(),e=this.config.getState(),g=this.config.getFadeType(),["btn-"+e,"btn-"+g].forEach(function(a){h=document.getElementsByClassName(a)[0],h&&this.activateButton(h)},this);for(a in j){c=f.getElementsByClassName(a)[0],this.ctrls[a]=c;for(b in j[a])c&&(d=i[j[a][b]].bind(i),c.addEventListener(b,d))}this.ctrls["time-format"]&&(this.ctrls["time-format"].value=this.config.getTimeFormat()),this.timeFormat=this.config.getTimeFormat(),this.currentSelectionValues=void 0,this.onCursorSelection({start:0,end:0})},changeDefaultFade:function(a){var b=a.currentTarget,c=b.parentElement.getElementsByClassName("active")[0],d=b.dataset.fade;this.deactivateButton(c),this.activateButton(b),this.config.setFadeType(d)},changeTimeFormat:function(a){var b,c,d,e=a.target.value;e=void 0!==this.cueFormatters(e)?e:"hh:mm:ss",this.config.setTimeFormat(e),this.timeFormat=e,void 0!==this.currentSelectionValues&&(b=this.cueFormatters(e),c=this.currentSelectionValues.start,d=this.currentSelectionValues.end,this.ctrls["audio-start"]&&(this.ctrls["audio-start"].value=b(c)),this.ctrls["audio-end"]&&(this.ctrls["audio-end"].value=b(d)))},zoomIn:function(){var a=.75*this.config.getResolution(),b=this.config.getMinResolution();a=b>a?b:a,a>b&&this.zoom(a)},zoomOut:function(){var a=this.config.getResolution()*(4/3),b=this.config.getMaxResolution();a=a>b?b:a,b>a&&this.zoom(a)},zoom:function(a){this.config.setResolution(a),this.fire("changeresolution",a)},validateCueIn:function(a){var b,c,d=a.target.value;return this.validateCue(d)&&(b=this.currentSelectionValues.end,c=this.cueToSeconds(d),b>=c)?(this.notifySelectionUpdate(c,b),void(this.currentSelectionValues.start=c)):void(a.target.value=this.cueFormatters(this.timeFormat)(this.currentSelectionValues.start))},validateCueOut:function(a){var b,c,d=a.target.value;return this.validateCue(d)&&(b=this.currentSelectionValues.start,c=this.cueToSeconds(d),c>=b)?(this.notifySelectionUpdate(b,c),void(this.currentSelectionValues.end=c)):void(a.target.value=this.cueFormatters(this.timeFormat)(this.currentSelectionValues.end))},activateButtonGroup:function(a){var b,c,d,e=document.getElementById(a),f=this.classes;if(null!==e)for(b=e.children,c=0,d=b.length;d>c;c++)b[c].classList.remove(f.disabled)},deactivateButtonGroup:function(a){var b,c,d,e=document.getElementById(a),f=this.classes;if(null!==e)for(b=e.children,c=0,d=b.length;d>c;c++)b[c].classList.add(f.disabled)},activateAudioSelection:function(){var a,b,c=this.groups["audio-select"];for(a=0,b=c.length;b>a;a++)this.activateButtonGroup(c[a])},deactivateAudioSelection:function(){var a,b,c=this.groups["audio-select"];for(a=0,b=c.length;b>a;a++)this.deactivateButtonGroup(c[a])},save:function(){this.fire("playlistsave",this)},open:function(){this.fire("playlistrestore",this)},rewindAudio:function(){this.fire("rewindaudio",this)},fastForwardAudio:function(){this.fire("fastforwardaudio",this)},playAudio:function(){this.fire("playaudio",this)},pauseAudio:function(){this.fire("pauseaudio",this)},stopAudio:function(){this.fire("stopaudio",this)},activateButton:function(a){a&&a.classList.add(this.classes.active)},deactivateButton:function(a){a&&a.classList.remove(this.classes.active)},enableButton:function(a){a&&a.classList.remove(this.classes.disabled)},disableButton:function(a){a&&a.classList.add(this.classes.disabled)},changeState:function(a){var b=a.currentTarget,c=b.parentElement.getElementsByClassName("active")[0],d=b.dataset.state;this.deactivateButton(c),this.activateButton(b),this.config.setState(d),this.fire("changestate",this)},trimAudio:function(a){var b,c=a.target,d=this.classes;b=c.classList.contains(d.disabled),b||this.fire("trackedit",{type:"trimAudio"})},createFade:function(a){var b,c=a.target,d=c.dataset.shape,e=c.dataset.type,f=this.classes;b=c.classList.contains(f.disabled),b||this.fire("trackedit",{type:"createFade",args:{type:e,shape:d}})},onAudioSelection:function(){this.activateAudioSelection()},onAudioDeselection:function(){this.deactivateAudioSelection()},notifySelectionUpdate:function(a,b){this.fire("changeselection",{start:a,end:b})},onCursorSelection:function(a){var b=this.cueFormatters(this.timeFormat)(a.start),c=this.cueFormatters(this.timeFormat)(a.end),d=this.cueToSeconds(b),e=this.cueToSeconds(c);this.currentSelectionValues={start:d,end:e},this.ctrls["audio-start"]&&(this.ctrls["audio-start"].value=b),this.ctrls["audio-end"]&&(this.ctrls["audio-end"].value=c)},onAudioUpdate:function(a){this.ctrls["audio-pos"]&&(this.ctrls["audio-pos"].innerHTML=this.cueFormatters(this.timeFormat)(a.seconds))}},WaveformPlaylist.fades={sCurveFadeIn:function(a,b,c,d){var e;e=this.createSCurveBuffer(this.sampleRate,Math.PI/2),a.setValueCurveAtTime(e,b,c)},sCurveFadeOut:function(a,b,c,d){var e;e=this.createSCurveBuffer(this.sampleRate,-(Math.PI/2)),a.setValueCurveAtTime(e,b,c)},linearFadeIn:function(a,b,c,d){a.linearRampToValueAtTime(0,b),a.linearRampToValueAtTime(1,b+c)},linearFadeOut:function(a,b,c,d){a.linearRampToValueAtTime(1,b),a.linearRampToValueAtTime(0,b+c)},exponentialFadeIn:function(a,b,c,d){a.exponentialRampToValueAtTime(.01,b),a.exponentialRampToValueAtTime(1,b+c)},exponentialFadeOut:function(a,b,c,d){a.exponentialRampToValueAtTime(1,b),a.exponentialRampToValueAtTime(.01,b+c)},logarithmicFadeIn:function(a,b,c,d){var e,f=d.base;f="undefined"!=typeof f?f:10,e=this.createLogarithmicBuffer(this.sampleRate,f,1),a.setValueCurveAtTime(e,b,c)},logarithmicFadeOut:function(a,b,c,d){var e,f=d.base;f="undefined"!=typeof f?f:10,e=this.createLogarithmicBuffer(this.sampleRate,f,-1),a.setValueCurveAtTime(e,b,c)},createFadeIn:function(a,b,c){var d=b+"FadeIn",e=this[d];e.call(this,a,c.start,c.duration,c)},createFadeOut:function(a,b,c){var d=b+"FadeOut",e=this[d];e.call(this,a,c.start,c.duration,c)}},WaveformPlaylist.mixin(WaveformPlaylist.fades,WaveformPlaylist.curves),WaveformPlaylist.Storage={save:function(a,b){var c=JSON.stringify(b);localStorage.setItem(a,c)},restore:function(a){var b,c=localStorage.getItem(a);return b=JSON.parse(c)}},WaveformPlaylist.AudioPlayout={init:function(){this.ac=this.config.getAudioContext(),this.fadeMaker=Object.create(WaveformPlaylist.fades,{sampleRate:{value:this.ac.sampleRate}}),this.fadeGain=void 0,this.destination=this.ac.destination},getBuffer:function(){return this.buffer},applyFades:function(a,b,c){var d,e,f,g,h,i;this.fadeGain=this.ac.createGain();for(d in a)e=a[d],b>=e.end||(b<=e.start?(h=c+(e.start-b),i=e.end-e.start):b>e.start&&b<e.end&&(h=c-(b-e.start),i=e.end-e.start),g={start:h,duration:i},a.hasOwnProperty(d)&&(f=this.fadeMaker["create"+e.type],f.call(this.fadeMaker,this.fadeGain.gain,e.shape,g)))},loadData:function(a,b){var c=this;this.ac.decodeAudioData(a,function(a){c.buffer=a,b(a)},function(a){console.log("err(decodeAudioData): "+a),b(null,a)})},isPlaying:function(){return void 0!==this.source},getDuration:function(){return this.buffer.duration},onSourceEnded:function(a){this.source.disconnect(),this.source=void 0,this.fadeGain.disconnect(),this.fadeGain=void 0},setUpSource:function(){this.source=this.ac.createBufferSource(),this.source.buffer=this.buffer,this.source.onended=this.onSourceEnded.bind(this),this.source.connect(this.fadeGain),this.fadeGain.connect(this.destination)},play:function(a,b,c){this.setUpSource(),this.source.start(a||0,b,c)},stop:function(a){this.source&&this.source.stop(a||0)}},WaveformPlaylist.TimeScale={init:function(){function a(){f.width=f.container.clientWidth,f.height=f.container.clientHeight,c.setAttribute("width",f.width),c.setAttribute("height",f.height),f.drawScale()}function b(){clearTimeout(e),e=setTimeout(a,100)}var c,d,e,f=this;WaveformPlaylist.makePublisher(this),d=document.querySelector(".playlist-time-scale"),d.style.position="relative",d.style.left=0,d.style.right=0,void 0!==d&&(c=document.createElement("canvas"),this.canv=c,this.context=c.getContext("2d"),this.container=d,this.width=this.container.clientWidth,this.height=this.container.clientHeight,c.setAttribute("width",this.width),c.setAttribute("height",this.height),c.style.position="absolute",c.style.left=0,c.style.right=0,c.style.top=0,c.style.bottom=0,this.times=[],this.prevScrollPos=0,this.onResize=b,this.drawScale())},formatTime:function(a){var b,c,d;return d=a%60,c=(a-d)/60,10>d&&(d="0"+d),b=c+":"+d},clear:function(){this.container.innerHTML="",this.context.clearRect(0,0,this.width,this.height)},drawScale:function(a){var b,c,d,e,f,g,h,i,j,k=this.context,l=this.canv,m=this.config.getColorScheme(),n=this.config.getResolution(),o=this.config.getSampleRate(),p=o/n,q=a||0,r=0,s=this.container,t=this.width,u=this.height,v=document.createDocumentFragment();for(this.clear(),v.appendChild(l),k.fillStyle=m.timeColor,d=t+q,c=0;d>c;c+=p)e=~~c,b=e-q,e>=q&&(r%30===0?(h=this.formatTime(r),g=document.createTextNode(h),f=document.createElement("div"),f.style.position="absolute",f.style.left=b+"px",f.appendChild(g),v.appendChild(f),j=10,i=u-j):r%5===0?(j=5,i=u-j):(j=2,i=u-j),k.fillRect(b,i,1,j)),r++;s.appendChild(v)},onTrackScroll:function(){var a=this.config.getTrackScroll(),b=a.left;b!==this.prevScrollPos&&(this.prevScrollPos=b,this.drawScale(b))},onResolutionChange:function(){var a=this.config.getTrackScroll(),b=a.left;this.drawScale(b)}},WaveformPlaylist.TrackEditor={init:function(a,b,c,d,e,f){var g={cursor:!0,fadein:!0,fadeout:!0,select:!0,shift:!0};if(Object.keys(g).forEach(function(a){g[a]=a in f?f[a]:g[a]}),this.enabledStates=g,WaveformPlaylist.makePublisher(this),this.container=document.createElement("div"),this.container.classList.add("channel-wrapper"),this.container.style.position="relative",this.drawer=Object.create(WaveformPlaylist.WaveformDrawer,{config:{value:this.config},container:{value:this.container}}),this.drawer.init(),this.playout=Object.create(WaveformPlaylist.AudioPlayout,{config:{value:this.config}}),this.playout.init(),this.sampleRate=this.config.getSampleRate(),this.resolution=this.config.getResolution(),this.startTime=b||0,this.endTime=c||0,this.setState(this.config.getState()),this.fades={},void 0!==d&&d.length>0)for(var h=0;h<d.length;h++)this.fades[this.getFadeId()]=d[h];return void 0!==e&&(this.cuein=e.cuein,this.cueout=e.cueout),this.active=!1,this.selectedArea=void 0,this.drawer.drawLoading(),this.container},setLeftOffset:function(a){this.leftOffset=a,this.drawer.setPixelOffset(a/this.resolution),this.fire("changeshift")},getFadeId:function(){var a=""+Math.random();return a.replace(".","")},getBuffer:function(){return this.playout.getBuffer()},loadTrack:function(a){var b;return b=this.init(a.src,a.start,a.end,a.fades,{cuein:a.cuein,cueout:a.cueout},a.states||{}),void 0!==a.selected&&(this.selectedArea={startTime:a.selected.start,endTime:a.selected.end}),this.loadBuffer(a.src),b},loadBuffer:function(a){var b=this,c=new XMLHttpRequest;c.open("GET",a,!0),c.responseType="arraybuffer",c.addEventListener("progress",function(a){var c;a.lengthComputable&&(c=a.loaded/a.total*100,b.drawer.updateLoader(c))},!1),c.addEventListener("load",function(c){b.src=a,b.drawer.setLoaderState("decoding"),b.playout.loadData(c.target.response,b.onTrackLoad.bind(b))},!1),c.send()},drawTrack:function(a){this.drawer.drawBuffer(a,this.cues),this.drawer.drawFades(this.fades)},onTrackLoad:function(a,b){var c,d,e,f;return void 0!==b?(this.container.innerHTML="",this.container.classList.add("error"),void this.fire("unregister")):(e=this.cuein&&this.secondsToSamples(this.cuein)||0,f=this.cueout&&this.secondsToSamples(this.cueout)||a.length,this.setCuePoints(e,f),this.drawTrack(a),this.setLeftOffset(this.secondsToSamples(this.startTime)),void(void 0!==this.selectedArea&&(c=this.selectedArea.startTime,d=this.selectedArea.endTime,this.notifySelectUpdate(c,d))))},activate:function(){this.active=!0,this.container.classList.add("active")},deactivate:function(){this.active=!1,this.container.classList.remove("active"),this.selectedArea&&(this.selectedArea=void 0,this.drawer.selection&&this.drawer.container.removeChild(this.drawer.selection),this.drawer.selection=void 0)},notifySelectUpdate:function(a,b,c){this.setSelectedArea(a,b,c),b>a?this.activateAudioSelection():this.deactivateAudioSelection(),this.fire("changecursor",{start:a,end:b,editor:this})},setSelectedArea:function(a,b,c){c&&a===b&&void 0!==this.prevSelectedArea&&(a>=this.prevSelectedArea.endTime?a=this.prevSelectedArea.startTime:a<=this.prevSelectedArea.startTime&&(b=this.prevSelectedArea.endTime)),this.prevSelectedArea=this.selectedArea,this.selectedArea={startTime:a,endTime:b},this.config.setCursorPos(a),this.showSelection()},activateAudioSelection:function(){this.fire("activateSelection")},deactivateAudioSelection:function(){this.fire("deactivateSelection")},saveFade:function(a,b,c,d,e){return this.fades[a]={type:b,shape:c,start:d,end:e},a},removeFade:function(a){delete this.fades[a],this.drawer.removeFade(a)},removeFadeType:function(a){var b,c,d=this.fades;for(b in d)c=d[b],c.type===a&&this.removeFade(b)},setCuePoints:function(a,b){var c=this.cues?this.cues.cuein:0,d=this.getBuffer(),e=this.cues?this.cues.cueout:d.length;0>a&&(a=0),c+b>e&&(b=e-c),this.cues={cuein:c+a,cueout:c+b},this.duration=(b-a)/this.sampleRate,this.endTime=this.duration+this.startTime,this.cuein=this.samplesToSeconds(this.cues.cuein),this.cueout=this.samplesToSeconds(this.cues.cueout)},trim:function(){var a,b,c=this.selectedArea;void 0!==c&&(a=this.secondsToSamples(c.startTime)-this.leftOffset,b=this.secondsToSamples(c.endTime)-this.leftOffset+1,this.setCuePoints(a,b),this.notifySelectUpdate(0,0),this.fades={},this.drawTrack(this.getBuffer()))},onTrackEdit:function(a){var b=a.type,c="on"+b.charAt(0).toUpperCase()+b.slice(1);this.active===!0&&this[c].call(this,a.args)},createFade:function(a,b,c,d){var e=(this.selectedArea,this.pixelsToSeconds(c)),f=this.pixelsToSeconds(d),g=this.getFadeId();this.notifySelectUpdate(0,0),this.saveFade(g,a,b,e,f),this.drawer.drawFade(g,a,b,c,d)},onCreateFade:function(a){this.createFade(a.type,a.shape),this.deactivateAudioSelection()},onTrimAudio:function(){var a=this.selectedArea;this.trim(a.start,a.end),this.deactivateAudioSelection()},setState:function(a){this.currentState&&this.currentState.leave.call(this),this.enabledStates[a]&&(this.currentState=WaveformPlaylist.states[a],this.currentState.enter.call(this))},onResolutionChange:function(a){var b=this.selectedArea;this.resolution=a,this.drawTrack(this.getBuffer()),this.drawer.setPixelOffset(this.leftOffset/a),this.active===!0&&void 0!==this.selectedArea&&this.drawer.drawHighlight(this.secondsToPixels(b.startTime),this.secondsToPixels(b.endTime)),this.fire("changeshift")},isPlaying:function(){return this.playout.isPlaying()},schedulePlay:function(a,b,c){var d,e,f,g=a,h=c?c-b:void 0,i=this.cues.cuein/this.sampleRate;this.endTime<=b||h&&b+h<this.startTime||(this.startTime>=b?(d=0,g=g+this.startTime-b,c?(h-=this.startTime-b,e=Math.min(h,this.duration)):e=this.duration):(d=b-this.startTime,e=c?Math.min(h,this.duration-d):this.duration-d),d+=i,f=b-this.startTime,this.playout.applyFades(this.fades,f,a),this.playout.play(g,d,e))},scheduleStop:function(a){this.playout.stop(a)},showProgress:function(a){this.drawer.updateProgress(this.secondsToPixels(a))},showSelection:function(){var a,b;a=this.secondsToPixels(this.selectedArea.startTime),b=this.secondsToPixels(this.selectedArea.endTime),this.drawer.drawHighlight(a,b)},getTrackDetails:function(){var a,b,c=this.cues,d=[];for(b in this.fades)d.push(this.fades[b]);return a={start:this.startTime,end:this.endTime,fades:d,src:this.src,cuein:this.samplesToSeconds(c.cuein),cueout:this.samplesToSeconds(c.cueout)}}},WaveformPlaylist.mixin(WaveformPlaylist.TrackEditor,WaveformPlaylist.unitConversions),WaveformPlaylist.WaveformDrawer={init:function(){WaveformPlaylist.makePublisher(this),this.channels=[],this.pixelOffset=0,this.containerWidth=0;var a=this.config.getUITheme();void 0!==this.loaderStates[a]?this.loaderStates=this.loaderStates[a]:this.loaderStates=this.loaderStates["default"]},loaderStates:{bootstrap:{downloading:"progress-bar",decoding:"progress-bar progress-bar-striped",loader:"bar"},jQueryUI:{downloading:"ui-progressbar ui-widget ui-widget-content ui-corner-all",decoding:"ui-progressbar ui-widget ui-widget-content ui-corner-all",loader:"ui-progressbar-value ui-widget-header ui-corner-left"},"default":{downloading:"progress",decoding:"decoding",loader:"bar"}},getPeaks:function(a,b){var c,d,e,f,g,h,i,j,k,l,m=this.config.getResolution(),n=[],o=b.cueout-b.cuein,p=Math.ceil(o/m),q=a.numberOfChannels,r=1/q,s=this.config.isDisplayMono(),t=-(1/0);

for(c=0;p>c;c++){for(n[c]=[],d=0;q>d;d++){for(g=a.getChannelData(d),g=g.subarray(b.cuein,b.cueout),h=c*m,i=(c+1)*m>o?o:(c+1)*m,j=g.subarray(h,i),k=-(1/0),l=1/0,e=0,f=j.length;f>e;e++)j[e]>k&&(k=j[e]),j[e]<l&&(l=j[e]);n[c].push({max:k,min:l}),t=Math.max.apply(Math,[t,Math.abs(k),Math.abs(l)])}if(s){for(k=l=0,d=0;q>d;d++)k+=r*n[c][d].max,l+=r*n[c][d].min;n[c]=[],n[c].push({max:k,min:l})}}this.maxPeak=t,this.peaks=n},setPixelOffset:function(a){a+this.width;this.pixelOffset=a,this.drawTimeShift(),this.containerWidth=a+this.width},drawTimeShift:function(){var a,b;for(a=0,b=this.channels.length;b>a;a++)this.channels[a].div.style.left=this.pixelOffset+"px"},updateLoader:function(a){this.loader.style.width=a+"%"},setLoaderState:function(a){this.loader.className=this.loaderStates[a]},drawLoading:function(){var a,b;this.height=this.config.getWaveHeight(),a=document.createElement("div"),a.style.height=this.height+"px",b=document.createElement("div"),b.style.height="10px",b.className=this.loaderStates.loader,a.appendChild(b),this.loader=b,this.setLoaderState("downloading"),this.updateLoader(0),this.container.appendChild(a)},findLayerOffset:function(a){var b,c=0;return"CANVAS"===a.tagName?(b=a.parentNode,c=b.offsetLeft,b.classList.contains("playlist-fade")&&(b=b.parentNode,c+=b.offsetLeft)):a.classList.contains("selection")&&(c+=a.offsetLeft),c},drawBuffer:function(a,b){var c,d,e,f,g,h,i,j=0,k=0,l=this.config.isDisplayMono(),m=this.config.getResolution(),n=l?1:a.numberOfChannels,o=b.cueout-b.cuein+1,p=document.createDocumentFragment();for(this.container.innerHTML="",this.channels=[],this.selection=void 0,this.width=Math.ceil(o/m),this.height=this.config.getWaveHeight(),h=0;n>h;h++)d=document.createElement("div"),d.classList.add("channel"),d.classList.add("channel-"+h),d.style.width=this.width+"px",d.style.height=this.height+"px",d.style.top=j+"px",d.style.left=k+"px",d.style.position="absolute",d.style.margin=0,d.style.padding=0,d.style.zIndex=1,e=document.createElement("div"),e.classList.add("channel-progress"),e.style.position="absolute",e.style.width=0,e.style.height=this.height+"px",e.style.zIndex=2,c=document.createElement("canvas"),c.setAttribute("width",this.width),c.setAttribute("height",this.height),c.style.position="absolute",c.style.margin=0,c.style.padding=0,c.style.zIndex=3,g=document.createElement("canvas"),g.setAttribute("width",this.width),g.setAttribute("height",this.height),g.style.position="absolute",g.style.margin=0,g.style.padding=0,g.style.zIndex=4,this.channels.push({context:c.getContext("2d"),div:d,progress:e,surface:g.getContext("2d")}),d.appendChild(c),d.appendChild(e),d.appendChild(g),p.appendChild(d),j+=this.height;f=document.createElement("div"),f.classList.add("cursor"),f.style.position="absolute",f.style.boxSizing="content-box",f.style.margin=0,f.style.padding=0,f.style.top=0,f.style.left=0,f.style.bottom=0,f.style.zIndex=100,this.cursor=f,p.appendChild(f),i=n*this.height,this.container.style.height=i+"px",this.container.appendChild(p),this.getPeaks(a,b),this.draw(),this.drawTimeShift()},drawFrame:function(a,b,c){var d,e,f,g,h=this.height/2,i=this.channels[a].context,j=this.config.getColorScheme();f=Math.abs(c.max*h),g=Math.abs(c.min*h),e=1,d=b*e,i.fillStyle=j.waveOutlineColor,i.fillRect(d,0,e,h-f),i.fillRect(d,h+g,e,h-g)},draw:function(a,b){var c=this,d=this.peaks,e=this.pixelOffset,f=a?a-e:0,g=b?b-e+1:d.length;if(!(0>f&&0>g))for(0>f&&(f=0),g>d.length&&(g=d.length);g>f;f++)d[f].forEach(function(a,b){c.drawFrame(b,f,a)})},clear:function(){var a,b;for(a=0,b=this.channels.length;b>a;a++)this.channels[a].surface.clearRect(0,0,this.width,this.height)},updateProgress:function(a){this.drawProgress(a),this.drawCursor(a)},drawProgress:function(a){var b,c,d=Math.max(a-this.pixelOffset,0),e=Math.min(d,this.width);for(b=0,c=this.channels.length;c>b;b++)this.channels[b].progress.style.width=e+"px"},drawCursor:function(a){this.cursor.style.width=a+"px"},drawHighlight:function(a,b){var c,d=b-a+1,e=this.selection||document.createElement("div");c=1===d?"selection-cursor":"selection-segment",e.className="",e.classList.add(c),e.classList.add("selection"),e.style.position="absolute",e.style.width=d+"px",e.style.bottom=0,e.style.top=0,e.style.left=a+"px",e.style.zIndex=2e3,void 0===this.selection&&(this.container.appendChild(e),this.selection=e)},sCurveFadeIn:function(a){return this.createSCurveBuffer(a,Math.PI/2)},sCurveFadeOut:function(a){return this.createSCurveBuffer(a,-(Math.PI/2))},logarithmicFadeIn:function(a){return this.createLogarithmicBuffer(a,10,1)},logarithmicFadeOut:function(a){return this.createLogarithmicBuffer(a,10,-1)},exponentialFadeIn:function(a){return this.createExponentialBuffer(a,1)},exponentialFadeOut:function(a){return this.createExponentialBuffer(a,-1)},linearFadeIn:function(a){return this.createLinearBuffer(a,1)},linearFadeOut:function(a){return this.createLinearBuffer(a,-1)},drawFadeCurve:function(a,b,c,d){var e,f,g,h,i=b+c,j=this[i],k=this.config.getColorScheme(),l=this.height;for(a.strokeStyle=k.fadeColor,e=j.call(this,d),h=l-e[0]*l,a.beginPath(),a.moveTo(0,h),f=1,g=e.length;g>f;f++)h=l-e[f]*l,a.lineTo(f,h);a.stroke()},removeFade:function(a){var b,c,d,e,f="playlist-fade-"+a;if(c=this.container.getElementsByClassName(f),e=c.length,e>0)for(d=e-1;d>=0;d--)b=c[d],b.parentNode.removeChild(b)},drawFade:function(a,b,c,d,e){var f,g,h,i,j,k,l,m,n,o=document.createDocumentFragment();if(e-d!==0)for(h=~~(e-d+1),i=d,f=document.createElement("div"),f.classList.add("playlist-fade"),f.classList.add("playlist-fade-"+a),f.style.position="absolute",f.style.width=h+"px",f.style.height=this.height+"px",f.style.top=0,f.style.left=i+"px",f.style.zIndex=1e3,g=document.createElement("canvas"),g.setAttribute("width",h),g.setAttribute("height",this.height),m=g.getContext("2d"),this.drawFadeCurve(m,c,b,h),f.appendChild(g),o.appendChild(f),j=0,k=this.channels.length;k>j;j++)l=o.cloneNode(!0),n=l.querySelector("canvas").getContext("2d"),n.drawImage(g,0,0),this.channels[j].div.appendChild(l)},drawFades:function(a){var b,c,d,e,f=this.config.getSampleRate(),g=this.config.getResolution();for(b in a)c=a[b],a.hasOwnProperty(b)&&(d=c.start*f/g,e=c.end*f/g,this.drawFade(b,c.type,c.shape,d,e))}},WaveformPlaylist.mixin(WaveformPlaylist.WaveformDrawer,WaveformPlaylist.curves);